.text
.global	best_prod_indices
best_prod_indices:
        ## rdi is pointer to arr[]
        ## esi is the len of arr
        ## rdx is pointer to besti
        ## rcx is pointer to bestj
        cmpl    $2,%esi               # if(len < 2)
        jge     .INBOUNDS
        movl    $-2147483648, %eax    # return INT_MIN
        ret
.INBOUNDS:
        movl    $0,%r8d               # r8 is besti
        movl    $1,%r9d               # r9 is bestj
        movl    (%rdi,%r8,4),%eax
        imull   (%rdi,%r9,4),%eax     # eax is best
        movl    $0,%r10d              # r10d is i
.OUTERLOOP:
        cmpl    %r10d,%esi            # for(... i < len-1 ...)
        jg      .END_OUTER_LOOP
        movl    %r10d,%r11d           # 
        incl    %r11d                 # r11d is j=i+1
.INNERLOOP:
        cmpl    %r11d,%esi            # for(... j < len ...)
        jge     .END_INNER_LOOP
        movl    (%rdi,%r10,4),%r12d
        imull   (%rdi,%r11,4),%r12d   # r12d is prod = arr[i]*arr[j]
        cmpl    %eax,%r12d
        jle     .AFTER_UPDATE_BEST    # if( prod > best) 
        movl    %r12d,%eax            # best = prod
        movl    %r10d,%r8d            # besti = i
        movl    %r11d,%r9d            # bestj = j
.AFTER_UPDATE_BEST:
        incl    %r11d                 # j++
        jmp     .INNERLOOP
.END_INNER_LOOP:
        incl    %r10d                 # i++
        jmp     .OUTERLOOP
.END_OUTER_LOOP:
        movl    (%rdx),%r8d           # *seti = besti
        movl    (%rcx),%r9d           # *setj = bestj
        ret                           # eax is already best, return
